

Require ZFord ZFordcl.
Import ZFnats.
Import IZF.

Lemma isOrd_eqv1 : forall x,
  ZFord.isOrd x -> ZFordcl.isOrd x.
intros.
apply ZFord.isOrd_ind with (3:=H); intros.
 rewrite <- H2; trivial.

 apply ZFordcl.isOrd_intro; intros; auto.
 apply ZFord.isOrd_trans with b; trivial.
Qed.

Lemma isOrd_equiv : forall x,
  ZFord.isOrd x <-> ZFordcl.isOrd x.
split; intros.
 apply isOrd_eqv1; trivial.

 apply ZFordcl.isOrd_ind; trivial; intros.
  rewrite <- H2; auto.

  apply ZFord.isOrd_intro; intros; auto.
  apply ZFordcl.ClassicOrdinal.ord_incl_le in H4.
   apply le_case in H4.
   destruct H4.
    rewrite H4; trivial.

    apply ZFordcl.isOrd_trans with b; trivial.

   apply isOrd_eqv1; trivial.

   apply ZFordcl.isOrd_inv with y; trivial.
Qed.

Lemma succ_equiv : forall x,
  ZFord.isOrd x -> succ x == ZFord.osucc x.
intros.
apply eq_intro; intros.
 apply le_case in H0; destruct H0.
  rewrite H0; apply ZFord.lt_osucc; trivial.

  apply ZFord.ole_lts.
   apply ZFord.isOrd_inv with x; trivial.

   red; intros.
   apply ZFord.isOrd_trans with z; trivial.

 assert (ZFordcl.isOrd z).
  apply isOrd_eqv1.
  apply ZFord.isOrd_inv with (ZFord.osucc x); auto with *.
 apply ZFord.olts_le in H0.
 apply ZFordcl.ClassicOrdinal.ord_incl_le in H0; trivial.
 apply isOrd_eqv1; trivial.
Qed.

Hint Resolve isOrd_eqv1.
